SystemOrganization addCategory: #'CS520-HomeAutomation'!

RectangleMorph subclass: #HomeAutomationView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationView subclass: #DeviceView
	instanceVariableNames: 'device label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!DeviceView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:20'!
createFromDevice: aDevice
	| newDeviceView |
	newDeviceView := DeviceView new.
	newDeviceView setDevice: aDevice.
	^ newDeviceView.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:55'!
device
	^ device! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:00'!
isDeviceView
	^ true! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:02'!
justDroppedInto: aPotentialRoomView event: anEvent
	super justDroppedInto: aPotentialRoomView event: anEvent.
	(aPotentialRoomView isRoomView) ifTrue: [ self device attachTo: aPotentialRoomView room ].! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:43'!
justGrabbedFrom: formerOwner
	super justGrabbedFrom: formerOwner.
	(formerOwner isRoomView) ifTrue: [ self device detachFrom: formerOwner ].! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:19'!
modelUpdated
	self updateViewFromModel! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
resetViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:19'!
setDevice: aDevice 
	device := aDevice.
	device when: #updated send: #modelUpdated to: self.
	self resetViewFromModel.! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:03'!
setLabelProperties
	| newLabel |
	newLabel := StringMorph new.
	newLabel contents: device name.
	newLabel color: (Color black orColorUnlike: self color).
	self borderColor: newLabel color.
	label isNil
		ifTrue: [ 
			self addMorphCentered: newLabel.
			label := newLabel ]! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:54'!
setViewProperties
	self width: device width.
	self height: device height.
	self color: device color.
	! !

!DeviceView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:10'!
updateViewFromModel
	self setViewProperties.
	self setLabelProperties.! !

!HomeAutomationView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:34'!
isHomeAutomationView
	^ true! !

HomeAutomationView subclass: #RoomView
	instanceVariableNames: 'room'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!RoomView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:09'!
createFromRoom: aRoom
	| newRoomView |
	newRoomView := RoomView new.
	newRoomView setRoom: aRoom.
	^ newRoomView.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:08'!
addUser: aUser
	room addUser: aUser.
	self updateViewFromModel.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:49'!
installDevice: each atPosition: currPosition
	| newDeviceView |
	newDeviceView := DeviceView createFromDevice: each.
	newDeviceView position: currPosition.
	self addMorphFront: newDeviceView.
	^ newDeviceView! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:49'!
installDevices
	| currPosition hGap vGap |
	hGap := 5.
	vGap := 5.
	currPosition := hGap @ vGap.
	room attachedDevices
		do: [ :each | 
			| newDeviceView |
			self width > (currPosition x + each width + hGap)
				ifTrue: [ 
					newDeviceView := self installDevice: each atPosition: currPosition.
					currPosition := currPosition + ((newDeviceView width + hGap) @ 0) ] ]! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:54'!
isRoomView
	^ true! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:19'!
removeUser: aUser
	room removeUser: aUser.
	self updateViewFromModel.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:44'!
repelsMorph: aMorph event: ev
	^ (self wantsDroppedMorph: aMorph event: ev) not! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:22'!
resetViewFromModel
	self removeAllMorphs.
	self setViewProperties.
	self setLabelProperties.
	self installDevices.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:02'!
room
	^ room! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: room name.
	label color: (Color black orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
setRoom: aRoom
	room := aRoom.
	self resetViewFromModel.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/4/2013 22:19'!
setViewProperties
	self width: room width.
	self height: room height.
	self color: room color.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:10'!
updateViewFromModel
	self
		submorphsDo: [ :aSubMorph | 
			aSubMorph isHomeAutomationView
				ifTrue: [ aSubMorph updateViewFromModel ] ].
	self setViewProperties.! !

!RoomView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:01'!
wantsDroppedMorph: aMorph event: anEvent
	^ (aMorph isUserView) | (aMorph isDeviceView)! !

HomeAutomationView subclass: #UserView
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!UserView class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:15'!
createFromUser: aUser
	| newUserView |
	newUserView := UserView new.
	newUserView setUser: aUser.
	^ newUserView.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:48'!
isUserView
	^ true! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:12'!
justDroppedInto: aPotentialRoomView event: anEvent
	super justDroppedInto: aPotentialRoomView event: anEvent.
	(aPotentialRoomView isRoomView) ifTrue: [ aPotentialRoomView addUser: self user ].
	! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:55'!
justGrabbedFrom: formerOwner
	super justGrabbedFrom: formerOwner.
	(formerOwner isRoomView) ifTrue: [ formerOwner removeUser: self user ].! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
resetViewFromModel
	self setViewProperties.
	self setLabelProperties.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:16'!
setLabelProperties
	| label |
	label := StringMorph new.
	label contents: user name.
	label color: (Color blue orColorUnlike: self color).
	self borderColor: label color.
	self addMorphCentered: label! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:23'!
setUser: aUser
	user := aUser.
	self resetViewFromModel.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:24'!
setViewProperties
	self width: 35.
	self height: 80.
	self color: user color.! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:05'!
updateViewFromModel
"	self setViewProperties.
	self setLabelProperties."! !

!UserView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 16:54'!
user
	^ user! !

TestCase subclass: #HomeAutomationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/28/2013 19:48'!
setUp! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testAttachDeviceToRoom
	| room device |
	room := Room createWithSize: 50@100 withName: 'test' withColor: Color black.
	device := Camera new.
	device attachTo: room.
	
	self assert: (room hasDevice: device).
	self assert: (device isAttachedTo: room).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 19:20'!
testCreateCameraSensor
	| camera |
	camera := Camera createWithName: 'Camera 01'.
	self assert: (camera name = 'Camera 01').
	self assert: (camera size = (30@30)).
	self assert: (camera color = Color black).
	self assert: (camera height = 30).
	self assert: (camera width = 30).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
testCreateRoom
	| room |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	self assert: (room name = 'Kitchen').
	self assert: (room width = 50).
	self assert: (room height = 100).
	self assert: (room center = (25@50)).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 15:22'!
testCreateUser
	| user |
	user := User createWithName: 'simon'.
	self assert: (user name = 'simon').
	self assert: (user color = Color blue).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:27'!
testObserverDoesNotGetNotfiedOfUserEntry
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := DummyDevice new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self deny: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:51'!
testObserverDoesNotGetNotfiedOfUserExitAfterStopsObserving
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	mockObserver stopObserving: device.
	room removeUser: user.
	self assert: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:26'!
testObserverGetsNotfiedOfUserEntry
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:29'!
testObserverGetsNotfiedOfUserExit
	| room device user mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	device := Camera new.
	device attachTo: room.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (mockObserver detectedUser: user).
	room removeUser: user.
	self deny: (mockObserver detectedUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:01'!
testUserEntersRoom
	| room user |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	user := User createWithName: 'Tom'.
	room addUser: user.
	self assert: (room includesUser: user).! !

!HomeAutomationTest methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:52'!
testUserEntersRoomBeforeDevicesAttached
	| room user device mockObserver |
	room := Room createWithSize: 50@100 withName: 'Kitchen'.
	user := User createWithName: 'Tom'.
	room addUser: user.

	device := Camera new.
	mockObserver := MockObserver new.
	mockObserver observe: device.
	device attachTo: room.
	self assert: (mockObserver detectedUser: user).! !

Object subclass: #HomeAutomationDevice
	instanceVariableNames: 'handledEvents room name size color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationDevice subclass: #DummyDevice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/10/2013 00:04'!
attachTo: aRoom
	room := aRoom.
	aRoom addDevice: self.
	self observeRoom: aRoom.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:11'!
color
	^ color! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:11'!
color: aColor
	color := aColor.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:58'!
detachFrom: aRoom
	room removeDevice: self.
	self stopObservingRoom: room.
	room := nil.! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 13:36'!
handleEvent: anEvent with: messageParamAssoc
	handledEvents at: anEvent put: messageParamAssoc.! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 13:38'!
handlesEvent: anEvent
	^ handledEvents includes: anEvent! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:11'!
height
	^ size y! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 13:47'!
initialize
	super initialize.
	handledEvents := Dictionary new.
	room := nil.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 13:46'!
isAttachedTo: aRoom 
	^ aRoom hasDevice: self! !

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/7/2013 13:46'!
isAttachedToARoom
	^ room notNil! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 15:00'!
listenTo: aDevice forEvent: anEvent
	self halt.
	(self handlesEvent: anEvent)
		ifTrue: [ 
			| message param |
			message := self messageForEvent: anEvent.
			param := self paramForEvent: anEvent.
			aDevice
				when: anEvent
				send: message
				to: self
				with: param ]! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 17:13'!
name 
	^ name! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:12'!
name: aByteString 
	name := aByteString.! !

!HomeAutomationDevice methodsFor: 'associating' stamp: 'CameronRieck 3/10/2013 00:04'!
observeRoom: aRoom
	handledEvents
		associationsDo: [ :assoc | 
			| event message value |
			event := assoc key.
			message := assoc value key.
			value := assoc value value.
			aRoom
				when: event
				send: message
				to: self
				with: value ]! !

!HomeAutomationDevice methodsFor: 'events' stamp: 'CameronRieck 3/7/2013 17:13'!
size
	^ size! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:13'!
size: aSize
	size := aSize.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:59'!
stopObservingRoom: aRoom 
	aRoom removeActionsWithReceiver: self.! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:10'!
userEntersMessage
	^ (Association new) key: #userEnters: value: #aUser.
	! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:32'!
userExitsMessage
	^ (Association new) key: #userExits: value: #aUser.
	! !

!HomeAutomationDevice methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:12'!
width
	^ size x! !

HomeAutomationDevice subclass: #HomeAutomationObserver
	instanceVariableNames: 'usersTracked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 13:26'!
detectedUser: aUser 
	^ usersTracked includes: aUser.	
! !

!HomeAutomationObserver methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 13:26'!
initialize
	super initialize.
	usersTracked := Set new.
! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:03'!
isTrackingUsers
	^ (usersTracked size > 0)! !

!HomeAutomationObserver methodsFor: 'associating' stamp: 'CameronRieck 3/10/2013 00:17'!
observe: aDevice
	aDevice when: #userEnters send: #userEnters: to: self with: #aUser.
	aDevice when: #userExits send: #userExits: to: self with: #aUser.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:55'!
stopObserving: aDevice
	aDevice removeActionsWithReceiver: self. 
	! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 18:16'!
userEnters: aUser
	usersTracked add: aUser.! !

!HomeAutomationObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:34'!
userExits: aUser
	usersTracked remove: aUser.! !

HomeAutomationObserver subclass: #MockObserver
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!MockObserver class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:08'!
createWithName: aName
	| newObserver |
	newObserver := MockObserver new.
	newObserver name: aName.
	^ newObserver.! !

!MockObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:04'!
defaultColor
	^ Color lightBlue! !

!MockObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 17:19'!
initialize
	super initialize.
	self color: (self defaultColor).
	self size: 30@30.! !

!MockObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:18'!
userEnters: aUser
	super userEnters: aUser.
	self color: Color yellow.
	self triggerEvent: #updated.! !

!MockObserver methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:18'!
userExits: aUser
	super userExits: aUser.
	(self isTrackingUsers) ifFalse: [ self color: (self defaultColor) ].
	self triggerEvent: #updated.! !

HomeAutomationDevice subclass: #HomeAutomationSensor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

HomeAutomationSensor subclass: #Camera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Camera class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:02'!
createWithName: aName
	| newCamera |
	newCamera := Camera new.
	newCamera name: aName.
	^ newCamera.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/10/2013 00:19'!
attachTo: aRoom
	super attachTo: aRoom.
	aRoom usersPresent do: [ :each | self userEnters: each ].! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:32'!
initialize
	super initialize.
	self size: 30@30.
	self color: Color black.
	self handleEvent: #userEnters with: (self userEntersMessage).
	self handleEvent: #userExits with: (self userExitsMessage).! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:33'!
userEnters: aUser
	self triggerEvent: #userEnters with: aUser.! !

!Camera methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:33'!
userExits: aUser
	self triggerEvent: #userExits with: aUser.! !

!HomeAutomationSensor methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:01'!
initialize
	super initialize.
	name := ''.
	size := 0@0.
	color := Color white.! !

Object subclass: #Room
	instanceVariableNames: 'roomSize attachedDevices color name usersPresent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/2/2013 15:48'!
createWithSize: aPoint 
	| room |
	room := Room new.
	room setSize: aPoint.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:53'!
createWithSize: aPoint withName: aName
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	^ room.! !

!Room class methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:07'!
createWithSize: aPoint withName: aName withColor: aColor
	| room |
	room := Room new.
	room setSize: aPoint.
	room setName: aName.
	room setColor: aColor.
	^ room.! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/2/2013 15:41'!
addDevice: aDevice
	attachedDevices add: aDevice.! !

!Room methodsFor: 'updating' stamp: 'CameronRieck 3/7/2013 18:13'!
addUser: aUser 
	usersPresent add: aUser.
	self triggerEvent: #userEnters with: aUser.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:51'!
attachedDevices
	^ attachedDevices! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 12:16'!
center
	^ ((self width) / 2)@((self height) / 2)! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
color
	^ color! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 18:51'!
devices
	^ attachedDevices! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/3/2013 11:48'!
hasDevice: aDevice
	^ attachedDevices includes: aDevice! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 12:14'!
height
	^ roomSize y! !

!Room methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:02'!
includesUser: aUser 
	^ usersPresent includes: aUser.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/6/2013 20:01'!
initialize
	attachedDevices := OrderedCollection new.
	usersPresent := Set new.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
length
	^ roomSize y! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
name
	^ name! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:48'!
removeDevice: aDevice
	self triggerEvent: #deviceRemoved with: aDevice.
	(attachedDevices includes: aDevice) ifTrue: [ attachedDevices remove: aDevice ].
	! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/7/2013 14:37'!
removeUser: aUser
	self triggerEvent: #userExits with: aUser.
	usersPresent remove: aUser.
	! !

!Room methodsFor: 'associating' stamp: 'CameronRieck 3/3/2013 12:07'!
setColor: aColor
	color := aColor.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:54'!
setName: aName
	name := aName.! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/2/2013 15:35'!
setSize: aPoint 
	roomSize := aPoint.! !

!Room methodsFor: 'as yet unclassified' stamp: 'CameronRieck 3/9/2013 23:50'!
usersPresent
	^ usersPresent! !

!Room methodsFor: 'private' stamp: 'CameronRieck 3/3/2013 11:58'!
width
	^ roomSize x! !

Object subclass: #User
	instanceVariableNames: 'name color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS520-HomeAutomation'!

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/7/2013 15:20'!
createWithName: aName 
	| newUser |
	newUser := User new.
	newUser name: aName.
	newUser color: User defaultColor.
	^ newUser.! !

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/7/2013 15:20'!
createWithName: aName andColor: aColor
	| newUser |
	newUser := User new.
	newUser name: aName.
	newUser color: aColor.
	^ newUser.! !

!User class methodsFor: 'instance creation' stamp: 'CameronRieck 3/7/2013 15:20'!
defaultColor
	^ Color blue! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 15:19'!
color
	^ color! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 15:19'!
color: aColor
	color := aColor! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/7/2013 15:19'!
name
	^ name! !

!User methodsFor: 'accessing' stamp: 'CameronRieck 3/6/2013 20:00'!
name: aName 
	name := aName.! !
